#!/usr/bin/env bash

# CLI (auto update) updater script
#
# parameter:
#           * path where to save the backup
#           * url where to get the file tui.tar.gz

current_tmp_release_folder=/home/akkadianuser/tmp/akkappmanager_installation
current_release_zip_name=`echo $1 | sed -r "s/\x1B\[([0-9]{1,3}((;[0-9]{1,3})*)?)?[m|K]//g"`;
current_app_folder=/home/akkadianuser
backup_directory=/home/backups/akkappmanager/
backup_release_directory=${backup_directory}

current_app_folder=/home/akkadianuser

updater_file=$(basename "$1")

if [ ! -e ${backup_directory} ]
then
    mkdir ${backup_directory}
fi

if [ ! -e ${backup_release_directory} ]
then
    mkdir ${backup_release_directory}
fi

if [ -e ${current_tmp_release_folder} ]
then
    rm -Rf ${current_tmp_release_folder}
fi

if [ ! -e ${current_tmp_release_folder} ]
then
    mkdir ${current_tmp_release_folder}
fi


# Do we need to download the file?
if [[ ( ${current_release_zip_name} == "http"* ) || ( ${current_release_zip_name} == "ftp"* ) ]]
then
    echo 'getting external file'
    wget ${current_release_zip_name} -P ${current_tmp_release_folder}/

    echo 'unzipping current file'
    tar -xvzf ${current_tmp_release_folder}/$(basename ${current_release_zip_name}) -C ${current_tmp_release_folder}/
else
    sudo cp -Rf ${current_release_zip_name} ${current_tmp_release_folder}
    sudo tar -xvzf ${current_tmp_release_folder}/$(basename ${current_release_zip_name}) -C ${current_tmp_release_folder}/
fi

echo 'copying files...'
echo ${current_app_folder}
sudo cp -Rf ${current_app_folder}/sync_start_at_log ${current_app_folder}/sync_end_at_log ${current_tmp_release_folder}
sudo cp -Rf ${current_tmp_release_folder}/* ${current_tmp_release_folder}/.* ${current_app_folder}

echo 'changing permissions...'
dos2unix /home/akkadianuser/*
sudo chown -R akkadianuser:akkadianuser /home/akkadianuser
sudo chmod +x /home/akkadianuser/scripts/*


sudo rm -Rf venv/
sudo rm -Rf netifaces-0.10.4/
sudo rm -Rf build/
sudo rm -Rf dist/
sudo rm -Rf tui.tar.gz
sudo rm -Rf tui/
sudo rm -Rf akkadianAppManager.egg-info/
sudo rm -Rf /usr/lib/python2.7/site-packages/akkadianAppManager-1.0-py2.7.egg


echo 'compiling...'
sleep 5

################ 2019 08 09 Changes in apache cron to support jobs to be run only once if it is part of cluster ########
#verifying apache jobs, and migrating them to akkadianuser
akkadian_cron_content=$(sudo crontab -u root -l)
if [[ "$akkadian_cron_content" != *"write_master.sh"* ]]; then
    sudo mkdir /var/www/html/ha
    sudo chown -R apache:root /var/www/html/ha
    sudo chmod -R 755 /var/www/html/ha
    apache_cron_content="*/1 * * * * sh /home/akkadianuser/scripts/ha/write_master.sh"
    (sudo crontab -u root -l; echo "$apache_cron_content" ) | sudo crontab -u root -
fi
########################################################################################################################

#### Checking on old versions to add or not the apache cron
#### DO  NOT MODIFY TABS IN apache_cron_content!!!!!!!!!!!!!!
if [[ ! -d /opt/akkadian/aco-server ]]; then
    sudo crontab -u apache -r
    echo "Checking what to add.."
    if [[ -d /var/www/html/abs ]]; then
        if [[ -d /var/www/html/pme ]]; then
            # this is pme
            apache_cron_content=$"5 * * * * sh /home/akkadianuser/scripts/apm_cm_runner.sh \"php /var/www/html/pme/index.php --task=Sync\"
*/10 * * * * sh /home/akkadianuser/scripts/apm_cm_runner.sh \"php /var/www/html/pme/index.php --task=Schedule\"
*/10 * * * * sh /home/akkadianuser/scripts/apm_cm_runner.sh \"php /var/www/html/pme/index.php --task=BackupSchedule\" "

        else
            # this is abs
            apache_cron_content=$"* * * * * sh /home/akkadianuser/scripts/apm_cm_runner.sh \"php /var/www/html/asb/artisan schedule:run\""
        fi
    elif [[ -d /var/www/html/acm ]]; then
        # this is acm
        apache_cron_content=$"* * * * * sh /home/akkadianuser/scripts/apm_cm_runner.sh \"/usr/bin/php /var/www/html/acm/scheduler.php > /dev/null 2>&1\" "

    elif [[ -d /var/www/html/orc ]]; then
        # this is orc
        apache_cron_content=$"* * * * * sh /home/akkadianuser/scripts/apm_cm_runner.sh \"php /var/www/html/asb/artisan schedule:run\"
* * * * * sh /home/akkadianuser/scripts/apm_cm_runner.sh \"php /var/www/html/orc/artisan schedule:run\"
5 * * * * sh /home/akkadianuser/scripts/apm_cm_runner.sh \"php /var/www/html/pme/index.php --task=Sync\"
*/10 * * * * sh /home/akkadianuser/scripts/apm_cm_runner.sh \"php /var/www/html/pme/index.php --task=Schedule\"
*/10 * * * * sh /home/akkadianuser/scripts/apm_cm_runner.sh \"php /var/www/html/pme/index.php --task=BackupSchedule\""

    elif [[ -d /var/www/html/pme ]]; then
            apache_cron_content=$"5 * * * * sh /home/akkadianuser/scripts/apm_cm_runner.sh \"php /var/www/html/pme/index.php --task=Sync\"
*/10 * * * * sh /home/akkadianuser/scripts/apm_cm_runner.sh \"php /var/www/html/pme/index.php --task=Schedule\"
*/10 * * * * sh /home/akkadianuser/scripts/apm_cm_runner.sh \"php /var/www/html/pme/index.php --task=BackupSchedule\" "
    fi
    (sudo crontab -u apache -l; echo "$apache_cron_content" ) | sudo crontab -u apache -
fi


cd /home/akkadianuser
sudo python2.7 setup.py install

